YGS_low_comp_ver = 0.22

local options = { 
	type='group',
	desc = "Some of these are debugging comands use debug comands at your own risk",
	args = {
		open_p = {
			type = 'execute',
			name = 'open_p',
			desc = 'Opens permission GUI',
			func = function()
				YGS_GUI_Permission:Show()
			end
		},
		gui = {
			type = 'execute',
			name = 'gui',
			desc = 'Opens GUI',
			func = function()
				if YGSBAG ~= nill and YGSBANK ~= nill then
					YGS_Personal = {UnitName("player"), GetRealmName()}
					YGS_GUI_Personal:Show()
					YGS_GUI_Personal_Button2:Disable()
					YGS_GUI_Personal_Button3:Enable()
					YGS_GUI_Personal_Button4:Enable()
				else
					YssGuildShop:Print("Please initialize YssGuildShop by visiting the bank")
				end
			end
		},
		dump = {
			type = 'execute',
			name = 'Dump',
			desc = 'Dumps YGSDB into console -- debug',
			func = function()
				YssGuildShop:YGS_Data_Dump()
			end
		},
		nuke = {
			type = 'execute',
			name = 'Nuke',
			desc = 'Deletes all inventory data (yours and all shared data) -- debug',
			func = function()
				YssGuildShop:Nuke()
			end
		},
		share = {
			type = 'toggle',
			name = 'Share',
			desc = "Sets default for sharing new items",
			get = "IsShared",
			set = "ToggleIsShared",
			map = { [false] = "Disabled", [true] = "Enabled" }
		},
		sharetrue = {
			type = 'execute',
			name = 'Sharetrue',
			desc = "Sets all share values to true",
			func = function()
				YssGuildShop_share_set(true)
			end
		},
		sharefalse = {
			type = 'execute',
			name = 'Sharefalse',
			desc = "Sets all share values to false",
			func = function()
				YssGuildShop_share_set(false)
			end
		},
		record = {
			type = 'toggle',
			name = 'Record',
			desc = "Turn Recording on or off",
			get = "IsRecord",
			set = "ToggleIsRecord",
			map = { [false] = "Disabled", [true] = "Enabled" }
		}
	}
}


YssGuildShop = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceComm-2.0", "AceHook-2.1")
YssGuildShop:RegisterChatCommand("/YssGuildShop", "/ygs", options)

function YssGuildShop:OnInitialize()
	-- Called when the addon is loaded
end

function YssGuildShop:OnEnable()
	local ver_check = 0
	if YGSDB ~= nil and YGSDB ~= {} then -- remove if public release (remove everything enclosed in the if statment)
		for k=1,table.maxn(YGSDB) do
			if ver_check == 0 then
				if tonumber(YGSDB[k]["YGS_ID"][3]) < 0.22 then
					ver_check = 1
					self:Print("YGS inventory database has been cleared due to major version revision.")
					self:Print("Thank you for upgrading to version: "..GetAddOnMetadata("YssGuildShop", "Version"))
					YssGuildShop:Nuke()
				end
			end
		end
	end
	-- Called when the addon is enabled
	YGS_sending = YGS_timestamp()
	YGS_mailbox_open = 0
	YGS_in_combat = 0
	YGS_temp_perm = {}
	if YGS_value == nil then
		YGS_value = {}
	end
	if YGS_share_filter == nil then
		YGS_share_filter = {}
	end
	if YGS_value == nil then
		YGS_value = {}
		YGS_value["YGS_AC"] = true
	end
	YGS_Personal = {UnitName("player"), GetRealmName()}
	YGS_Guild = ""
	--self:RegisterEvent("BAG_UPDATE")
	self:RegisterEvent("BANKFRAME_OPENED")
	self:RegisterEvent("BANKFRAME_CLOSED")
	self:RegisterEvent("MAIL_SHOW")
	self:RegisterEvent("MAIL_CLOSED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	--self:RegisterEvent("CHAT_MSG_ADDON") --debug extreamly spammy to turn this on
	self:Hook( "OpenBackpack", "Hook_OpenBackpack", true )
	self:Hook( "ToggleBackpack", "Hook_ToggleBackpack", true )
	self:Hook( "OpenAllBags", "Hook_OpenAllBags", true )
	self:Hook( "OpenBag", "Hook_OpenBag", true )
	self:Hook( "ToggleBag", "Hook_ToggleBag", true )
	self:SetCommPrefix("YssGuildShop")
	self:RegisterComm("YssGuildShop", "GUILD", "ReceiveMessage")
	self:RegisterMemoizations({"|Hitem:", "]|h|r"})
	if YGS_settings == nil then
		YGS_settings = {}
		YGS_settings[0] = GetAddOnMetadata("YssGuildShop", "Version")
		YGS_settings[1] = true -- true for record data false for no recording
		YGS_settings[2] = true -- true for sharding data false for no sharing -- reset to false once testing is done
		YGS_settings[3] = false -- reserved for future use
		YGS_settings[4] = false -- reserved for future use
		YGS_settings[5] = false -- reserved for future use
		YGS_settings[6] = false -- reserved for future use
		YGS_settings[7] = false -- reserved for future use
		YGS_settings[8] = false -- reserved for future use
		YGS_settings[9] = false -- reserved for future use
	end
	GuildRoster()
end

function YssGuildShop:OnDisable()
	-- Called when the addon is disabled
end

function YssGuildShop:IsRecord()
    return YGS_settings[1]
end

function YssGuildShop:ToggleIsRecord()
    YGS_settings[1] = not YGS_settings[1]
    if YGS_settings[1] == false then
	YGSBANK = nil
	YGSBAG =  nil
    end
end

function YssGuildShop:IsShared()
    return YGS_settings[2]
end

function YssGuildShop:ToggleIsShared()
    YGS_settings[2] = not YGS_settings[2]
end

function YGS_timestamp()
	local hour,minute,t1,t2,t3,t4 = GetGameTime()
	local ygs_stamp = (date("%Y%m%d")*1000000)+(hour*10000)+(minute*100)+date("%S")
	return ygs_stamp
end

function YssGuildShop:Hook_OpenAllBags()
	self.hooks["OpenAllBags"]()
	--self:Print("OpenAllBags")
	self:BAG_UPDATE()
end

function YssGuildShop:Hook_ToggleBackpack()
	self.hooks["ToggleBackpack"]()
	--self:Print("ToggleBackpack")
	self:BAG_UPDATE()
end

function YssGuildShop:Hook_OpenBackpack()
	self.hooks["OpenBackpack"]()
	--self:Print("OpenBackpack")
	self:BAG_UPDATE()
end

function YssGuildShop:Hook_OpenBag(bagID)
	self.hooks["OpenBag"](bagID)
	--self:Print("OpenBag " .. bagID)
	self:BAG_UPDATE()
end

function YssGuildShop:Hook_ToggleBag(bagID)
	self.hooks["ToggleBag"](bagID)
	--self:Print("ToggleBag " .. bagID)
	self:BAG_UPDATE()
end

function YssGuildShop:BAG_UPDATE()
	if YGS_mailbox_open == 0 and YGS_in_combat == 0 then
		local uniquecheck = 0
		if YGS_settings[1] == true then
			if UnitAffectingCombat("player") ~= 1 then
				--self:Print("Bag's Changed") --debugline
				YGS_BAG_PARSE()
			end
		else
			if YGSDB ~= nil then
				for k=1,table.maxn(YGSDB) do
					if YGSDB[k]["YGS_ID"][1] == UnitName("player") then
						YGSDB[k] = {}
						YGSDB[k]["YGS_ID"] = self:ID()
						uniquecheck = 1
					end
					if uniquecheck == 0 then
						local ygs_db_leng = table.maxn(YGSDB)+1
						YGSDB[ygs_db_leng] = {}
						YGSDB[ygs_db_leng]["YGS_ID"] = self:ID()
					end
				end
			else
				YGSDB = {}
				YGSDB[1] = {}
				YGSDB[1]["YGS_ID"] = self:ID()
			end
			uniquecheck = 0
		end
	end
end

function YssGuildShop:BANKFRAME_OPENED()
	--self:Print("Bank Open")
	if YGS_settings[1] == true then
		YGS_BANK_PARSE()
		YGS_BAG_PARSE()
	end
end

function YssGuildShop:BANKFRAME_CLOSED()
	if YGS_settings[1] == true then
		--self:Print("Bank Close")
		YGS_BANK_PARSE()
		YGS_BAG_PARSE()
	end
end

function YssGuildShop:MAIL_SHOW()
	YGS_mailbox_open = 1
end

function YssGuildShop:MAIL_CLOSED()
	YGS_mailbox_open = 0
	self:BAG_UPDATE()
end

function YssGuildShop:PLAYER_REGEN_ENABLED()
	--self:Print("Leaving Combat")
	YGS_in_combat = 0
	self:BAG_UPDATE()
end

function YssGuildShop:PLAYER_REGEN_DISABLED()
	--self:Print("Entering Combat")
	YGS_in_combat = 1
end

function YssGuildShop:GUILD_ROSTER_UPDATE()
	--self:Print("Guild Roster Update")
	if IsInGuild() then 
		if YGS_permission == nil or YGS_permission == {} then
			YGS_permission = {}
			YGS_permission[1] = {false,true,true} -- {boolean if addmin, boolean if bank}
			YGS_permission[2] = {false,true,true}
			for k=3,GuildControlGetNumRanks() do
				YGS_permission[k] = {false,false,true}
			end
		end
		if YGS_permission ~= nil and YGS_permission ~= {} then
			if table.maxn(YGS_permission) > GuildControlGetNumRanks() then
				for k=1,table.maxn(YGS_permission)-GuildControlGetNumRanks() do
					table.remove(YGS_permission ,table.maxn(YGS_permission))
				end
			end
			if table.maxn(YGS_permission) < GuildControlGetNumRanks() then
				for k=1,GuildControlGetNumRanks()-table.maxn(YGS_permission) do
					table.insert(YGS_permission, {false,false,true})
				end
			end
		end
	end
end

function YssGuildShop:CHAT_MSG_ADDON(prefix, message, distribution, sender)
	if sender == UnitName("player") and prefix ~= "GC3" then
		self:Print("P: "..prefix)
		self:Print("M: "..message)
		self:Print("D: "..distribution)
		self:Print("S: "..sender)
		self:Print("sending msg with length of " .. string.len(message))
	end
end

--will be executed when guild addon msg is recived
function YssGuildShop:ReceiveMessage(prefix, sender, distribution, message)
	local uniquecheck = 0
	if message["YGS_ID"] ~= nil then
		if message["YGS_ID"][1] ~= UnitName("player") then
			if YGS_share~= nill and YGS_share ~= {} then
				for k=1,table.maxn(YGS_share) do
					if YGS_share[k]["YGS_ID"][1] == message["YGS_ID"][1] then
						if YGS_share[k]["YGS_ID"][2] < message["YGS_ID"][2] then
							YGS_share[k] = message
							self:Print("data recived from "..sender.." about "..message["YGS_ID"][1])
						else
							self:Send()
						end
						uniquecheck = 1
					end
				end
				if uniquecheck == 0  then
					YGS_share[table.maxn(YGS_share)+1] = message
					self:Print("data recived from "..sender.." about "..message["YGS_ID"][1])
				end
			else
				YGS_share = {}
				YGS_share[1] = message
				self:Print("data recived from "..sender.." about "..message["YGS_ID"][1])
			end
		end
	elseif message["YGS_AC"] then
		for itemID, value in pairs(message) do
			if value[1] == "no value set" then
				YssGuildShop_share_value(itemID)
			else
				YssGuildShop_share_value(itemID, value[1], value[2])
			end
		end
	end
end

-- sends only own sharable data
function YssGuildShop:Send()
	if YGS_timestamp() - YGS_sending >= 10 then
		if YGSDB~= nill and YGSDB ~= {} then
			for k=1,table.maxn(YGSDB) do
				if YGSDB[k]["YGS_ID"][1] == UnitName("player") and YGSDB[k]["YGS_ID"][4] == GetRealmName() then
					local guildsuccess = self:SendPrioritizedCommMessage("BULK","GUILD",YGSDB[k])
					--self:Print(YGS_timestamp() - YGS_sending .. " sec since last send") -- debug line
					YGS_sending = YGS_timestamp()
				end
			end
		end
		--self:Print("sending all data") -- debug line
		if YGS_share ~= nill and YGS_share ~= {} then
			for k=1,table.maxn(YGS_share) do
				self:SendPrioritizedCommMessage("BULK","GUILD",YGS_share[k])
			end
		end
		if YGS_value ~= nill and YGS_value ~= {} then
				self:SendPrioritizedCommMessage("BULK","GUILD",YGS_value)
		end
	end
end

-- DB testing functions
function YssGuildShop:YGS_Data_Dump()
	if YGSDB ~= nil and YGSDB ~= {} then
		for k=1,table.maxn(YGSDB) do
			if YGSDB[k]["YGS_ID"][1] == UnitName("player") then
				for i=1,table.maxn(YGSDB[k]) do
					self:Print(YGSDB[k][i][1].." "..YGSDB[k][i][2])
				end
			end
		end
	end
end

function YssGuildShop:Nuke()
	YGSDB = nill
	YGSBANK = nill
	YGSBAG = nill
	YGS_share = nill
	self:Print("All inventory data has been deleted")
end

function YssGuildShop:ID()
	local id = {UnitName("player"),YGS_timestamp(),GetAddOnMetadata("YssGuildShop", "Version"), GetRealmName()}
	return id
end

